#ifndef TRACE_CONFIG_H
#define TRACE_CONFIG_H

/**
 * Do NOT edit this file!
 * 
 * This is the default TRACE config file.
 * You may provide your own implementation at project level.
 * 
 * For this:
 * - Copy/paste this file into a folder named 'config' in
 *   you projects include/source directory.
 * - Add a compiler include path so that your file is seen
 *   before the default config file provided in the platform
 *   package.
 * - Adjust the content of your config file to your needs.
 * - Remove this comment in your config file.
 */

#include "stm32f7xx_hal.h"                      // Do not use "mcu/mcu.h" here!

extern "C" UART_HandleTypeDef huart1;           // Defined in main.c

#define USE_PLATFORM_F7_DISCO_GCC_TRACE         1

#define TRACE_UART_NUMBER                       0
#define TRACE_UART_HANDLE                       huart1
#define TRACE_UART_BAUD_RATE                    /* 115200, but given by STM32CubeMX tool configuration */
#define TRACE_UART_USE_TX_DMA                   false
#define TRACE_UART_CONSTRUCTOR_PARAMETERS       TRACE_UART_NUMBER, &TRACE_UART_HANDLE, TRACE_UART_USE_TX_DMA

#define TRACE_ADD_CRLF_SEQU                     0

#endif // TRACE_CONFIG_H
